# Class `wibox.widget.slider`

An interactive mouse based slider widget.

### Usage:

    wibox.widget {
        bar_shape           = gears.shape.rounded_rect,
        bar_height          = 3,
        bar_color           = beautiful.border_color,
        handle_color        = beautiful.bg_normal,
        handle_shape        = gears.shape.circle,
        handle_border_color = beautiful.border_color,
        handle_border_width = 1,
        value               = 25,
        widget              = wibox.widget.slider,
    }

### Info:

- Copyright: 2015 Grigory Mishchenko, 2016 Emmanuel Lepage Vallee
- Author: Grigory Mishchenko <grishkokot@gmail.com>,Emmanuel Lepage Vallee <elv1313@gmail.com>

## Functions

wibox.widget.slider ([args={}]) | Create a slider widget.

## Object properties

handle_shape | The slider handle shape.
handle_color | The slider handle color.
handle_margins | The slider handle margins.
handle_width | The slider handle width.
handle_border_color | The handle border_color.
handle_border_width | The handle border width.
bar_shape | The bar (background) shape.
bar_height | The bar (background) height.
bar_color | The bar (background) color.
bar_margins | The bar (background) margins.
bar_border_width | The bar (background) border width.
bar_border_color | The bar (background) border_color.
value | The slider value.
minimum | The slider minimum value.
maximum | The slider maximum value.
forced_height | Force a widget height.
forced_width | Force a widget width.
opacity | The widget opacity (transparency).
visible | The widget visibility.

## Signals

widget::layout_changed | When the layout (size) change.
widget::redraw_needed | When the widget content changed.
button::press | When a mouse button is pressed over the widget.
button::release | When a mouse button is released over the widget.
mouse::enter | When the mouse enter a widget.
mouse::leave | When the mouse leave a widget.

## Theme variables

beautiful.slider_bar_border_width | The bar (background) border width.
beautiful.slider_bar_border_color | The bar (background) border color.
beautiful.slider_handle_border_color | The handle border_color.
beautiful.slider_handle_border_width | The handle border width.
beautiful.slider_handle_width | The handle .
beautiful.slider_handle_shape | The handle shape.
beautiful.slider_bar_shape | The bar (background) shape.
beautiful.slider_bar_height | The bar (background) height.
beautiful.slider_bar_margins | The bar (background) margins.
beautiful.slider_handle_margins | The slider handle margins.
beautiful.slider_bar_color | The bar (background) color.

## Methods

wibox.widget.slider:get_all_children () | Get all direct and indirect children widgets.
wibox.widget.slider:setup (args) | Set a declarative widget hierarchy description.
wibox.widget.slider:buttons (_buttons) | Set/get a widget's buttons.
wibox.widget.slider:emit_signal_recursive (signal_name, ...) | Emit a signal and ensure all parent widgets in the hierarchies also forward the signal.
wibox.widget.slider:emit_signal (name, ...) | Emit a signal.
wibox.widget.slider:connect_signal (name, func) | Connect to a signal.
wibox.widget.slider:weak_connect_signal (name, func) | Connect to a signal weakly.

## Functions

Methods

wibox.widget.slider ([args={}])
  Create a slider widget.
  - args table (default {})

## Object properties

handle_shape
  The slider handle shape.

  ### Type:

  - shape gears.shape (default gears shape rectangle)

  ### See also:

  gears.shape
handle_color
  The slider handle color.

  ### Type:

  - color
handle_margins
  The slider handle margins.

  ### Type:

  - margins
    - left number (default 0)
    - right number (default 0)
    - top number (default 0)
    - bottom number (default 0)
handle_width
  The slider handle width.

  ### Type:

  - number
handle_border_color
  The handle border_color.

  ### Type:

  - color
handle_border_width
  The handle border width.

  ### Type:

  - number (default 0)
bar_shape
  The bar (background) shape.

  ### Type:

  - shape gears.shape (default gears shape rectangle)

  ### See also:

  gears.shape
bar_height
  The bar (background) height.

  ### Type:

  - number
bar_color
  The bar (background) color.

  ### Type:

  - color
bar_margins
  The bar (background) margins.

  ### Type:

  - margins
    - left number (default 0)
    - right number (default 0)
    - top number (default 0)
    - bottom number (default 0)
bar_border_width
  The bar (background) border width.

  ### Type:

  - numbergb (default 0)
bar_border_color
  The bar (background) border_color.

  ### Type:

  - color
value
  The slider value.

  Signal: property::value notify the value is changed.

  ### Type:

  - number (default 0)
minimum
  The slider minimum value.

  ### Type:

  - number (default 0)
maximum
  The slider maximum value.

  ### Type:

  - number (default 100)
forced_height
  Force a widget height.

  ### Type:

  - height number or nil The height (`nil` for automatic)
forced_width
  Force a widget width.

  ### Type:

  - width number or nil The width (`nil` for automatic)
opacity
  The widget opacity (transparency).

  ### Type:

  - opacity number The opacity (between 0 and 1) (default 1)
visible
  The widget visibility.

  ### Type:

  - boolean

## Signals

widget::layout_changed
  When the layout (size) change. This signal is emitted when the previous results of `:layout()` and `:fit()` are no longer valid. Unless this signal is emitted, `:layout()` and `:fit()` must return the same result when called with the same arguments.

  ### See also:

  widget::redraw_needed
widget::redraw_needed
  When the widget content changed. This signal is emitted when the content of the widget changes. The widget will be redrawn, it is not re-layouted. Put differently, it is assumed that `:layout()` and `:fit()` would still return the same results as before.

  ### See also:

  widget::layout_changed
button::press
  When a mouse button is pressed over the widget.

  ### Arguments:

  - lx number The horizontal position relative to the (0,0) position in the widget.
  - ly number The vertical position relative to the (0,0) position in the widget.
  - button number The button number.
  - mods table The modifiers (mod4, mod1 (alt), Control, Shift)
  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
button::release
  When a mouse button is released over the widget.

  ### Arguments:

  - lx number The horizontal position relative to the (0,0) position in the widget.
  - ly number The vertical position relative to the (0,0) position in the widget.
  - button number The button number.
  - mods table The modifiers (mod4, mod1 (alt), Control, Shift)
  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
mouse::enter
  When the mouse enter a widget.

  ### Arguments:

  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
mouse::leave
  When the mouse leave a widget.

  ### Arguments:

  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse

## Theme variables

beautiful.slider_bar_border_width
  The bar (background) border width.

  ### Type:

  - number
beautiful.slider_bar_border_color
  The bar (background) border color.

  ### Type:

  - color
beautiful.slider_handle_border_color
  The handle border_color.

  ### Type:

  - color
beautiful.slider_handle_border_width
  The handle border width.

  ### Type:

  - number
beautiful.slider_handle_width
  The handle .

  ### Type:

  - number
beautiful.slider_handle_shape
  The handle shape.

  ### Type:

  - shape gears.shape (default gears shape rectangle)

  ### See also:

  gears.shape
beautiful.slider_bar_shape
  The bar (background) shape.

  ### Type:

  - shape gears.shape (default gears shape rectangle)

  ### See also:

  gears.shape
beautiful.slider_bar_height
  The bar (background) height.

  ### Type:

  - number
beautiful.slider_bar_margins
  The bar (background) margins.

  ### Type:

  - margins
    - left number (default 0)
    - right number (default 0)
    - top number (default 0)
    - bottom number (default 0)
beautiful.slider_handle_margins
  The slider handle margins.

  ### Type:

  - margins
    - left number (default 0)
    - right number (default 0)
    - top number (default 0)
    - bottom number (default 0)
beautiful.slider_bar_color
  The bar (background) color.

  ### Type:

  - color

## Methods

wibox.widget.slider:get_all_children ()
  Get all direct and indirect children widgets. This will scan all containers recursively to find widgets Warning: This method it prone to stack overflow id the widget, or any of its children, contain (directly or indirectly) itself.

  ### Returns:

  table The children
wibox.widget.slider:setup (args)
  Set a declarative widget hierarchy description. See The declarative layout system
  - args An array containing the widgets disposition
wibox.widget.slider:buttons (_buttons)
  Set/get a widget's buttons.
  - _buttons The table of buttons that should bind to the widget.
wibox.widget.slider:emit_signal_recursive (signal_name, ...)
  Emit a signal and ensure all parent widgets in the hierarchies also forward the signal. This is useful to track signals when there is a dynamic set of containers and layouts wrapping the widget.
  - signal_name string
  - ... Other arguments
wibox.widget.slider:emit_signal (name, ...)
  Emit a signal.
  - name string The name of the signal.
  - ... Extra arguments for the callback functions. Each connected function receives the object as first argument and then any extra arguments that are given to emit_signal().
wibox.widget.slider:connect_signal (name, func)
  Connect to a signal.
  - name string The name of the signal.
  - func function The callback to call when the signal is emitted.
wibox.widget.slider:weak_connect_signal (name, func)
  Connect to a signal weakly.

  This allows the callback function to be garbage collected and automatically disconnects the signal when that happens.

  Warning: Only use this function if you really, really, really know what you are doing.

  - name string The name of the signal.
  - func function The callback to call when the signal is emitted.

generated by LDoc 1.5.0 Last updated 2025-09-26 21:04:17